From 65bc8e6af849243b56e032a9ca2c52df596e10e5 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: May 11 2020 07:30:24 +0000
Subject: [PATCH 611/2232] Detect earlier untyped discriminants out of bounds of later suffix


---

diff --git a/syntax/discriminant.rs b/syntax/discriminant.rs
index 35ef4cb..6a04d88 100644
--- a/syntax/discriminant.rs
+++ b/syntax/discriminant.rs
@@ -32,7 +32,21 @@ impl DiscriminantSet {
     pub fn insert(&mut self, expr: &Expr) -> Result<Discriminant> {
         let (discriminant, repr) = expr_to_discriminant(expr)?;
         match (self.repr, repr) {
-            (None, _) => self.repr = repr,
+            (None, Some(new_repr)) => {
+                if let Some(limits) = Limits::of(new_repr) {
+                    for &past in &self.values {
+                        if limits.min <= past && past <= limits.max {
+                            continue;
+                        }
+                        let msg = format!(
+                            "discriminant value `{}` is outside the limits of {}",
+                            past, new_repr,
+                        );
+                        return Err(Error::new(Span::call_site(), msg));
+                    }
+                }
+                self.repr = Some(new_repr);
+            }
             (Some(prev), Some(repr)) if prev != repr => {
                 let msg = format!("expected {}, found {}", prev, repr);
                 return Err(Error::new(Span::call_site(), msg));
@@ -109,18 +123,14 @@ fn expr_to_discriminant(expr: &Expr) -> Result<(Discriminant, Option<Atom>)> {
 
 fn insert(set: &mut DiscriminantSet, discriminant: Discriminant) -> Result<Discriminant> {
     if let Some(expected_repr) = set.repr {
-        for limits in &LIMITS {
-            if limits.repr != expected_repr {
-                continue;
-            }
-            if limits.min <= discriminant && discriminant <= limits.max {
-                break;
+        if let Some(limits) = Limits::of(expected_repr) {
+            if discriminant < limits.min || limits.max < discriminant {
+                let msg = format!(
+                    "discriminant value `{}` is outside the limits of {}",
+                    discriminant, expected_repr,
+                );
+                return Err(Error::new(Span::call_site(), msg));
             }
-            let msg = format!(
-                "discriminant value `{}` is outside the limits of {}",
-                discriminant, expected_repr,
-            );
-            return Err(Error::new(Span::call_site(), msg));
         }
     }
     if set.values.insert(discriminant) {
@@ -230,12 +240,24 @@ fn parse_int_suffix(suffix: &str) -> Result<Option<Atom>> {
     Err(Error::new(Span::call_site(), msg))
 }
 
+#[derive(Copy, Clone)]
 struct Limits {
     repr: Atom,
     min: Discriminant,
     max: Discriminant,
 }
 
+impl Limits {
+    fn of(repr: Atom) -> Option<Limits> {
+        for limits in &LIMITS {
+            if limits.repr == repr {
+                return Some(*limits);
+            }
+        }
+        None
+    }
+}
+
 const LIMITS: [Limits; 8] = [
     Limits {
         repr: U8,
diff --git a/tests/ui/enum_out_of_bounds.rs b/tests/ui/enum_out_of_bounds.rs
index 1aec5f0..9e0090b 100644
--- a/tests/ui/enum_out_of_bounds.rs
+++ b/tests/ui/enum_out_of_bounds.rs
@@ -1,9 +1,13 @@
 #[cxx::bridge]
 mod ffi {
     #[repr(u32)]
-    enum Bad {
+    enum Bad1 {
         A = 0xFFFF_FFFF_FFFF_FFFF,
     }
+    enum Bad2 {
+        A = 2000,
+        B = 1u8,
+    }
 }
 
 fn main() {}
diff --git a/tests/ui/enum_out_of_bounds.stderr b/tests/ui/enum_out_of_bounds.stderr
index f437ea1..5d02e20 100644
--- a/tests/ui/enum_out_of_bounds.stderr
+++ b/tests/ui/enum_out_of_bounds.stderr
@@ -3,3 +3,9 @@ error: discriminant value `18446744073709551615` is outside the limits of u32
   |
 5 |         A = 0xFFFF_FFFF_FFFF_FFFF,
   |         ^^^^^^^^^^^^^^^^^^^^^^^^^
+
+error: discriminant value `2000` is outside the limits of u8
+ --> $DIR/enum_out_of_bounds.rs:9:9
+  |
+9 |         B = 1u8,
+  |         ^^^^^^^

